<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace NWCModule\Lib;


use itnovum\openITCOCKPIT\Core\Wizards\ModuleWizardsInterface;

class Wizards implements ModuleWizardsInterface {

    /**
     * @var array
     */
    private $ACL_PERMISSIONS = [];

    /**
     * Widgets constructor.
     * @param $ACL_PERMISSIONS
     */
    public function __construct($ACL_PERMISSIONS) {
        $this->ACL_PERMISSIONS = $ACL_PERMISSIONS;
    }

    /**
     * @return array
     */
    public function getAvailableWizards() {
        if (!(isset($this->ACL_PERMISSIONS['hosts']['add']) && isset($this->ACL_PERMISSIONS['services']['add']))) {
            return [];
        }
        $wizards = [
            'network' => [
                'type_id'                 => 'network',
                'uuid'                    => 'cf3abeba-80f8-4307-8b86-c198cc9c576e',
                'title'                   => __('Network'),
                'description'             => __('Used to check any kind of network devices and interfaces like: Switch, Router, Firewall, Access Point, ...'),
                'image'                   => 'network.png',
                'directive'               => 'network', //AngularJS directive
                'state'                   => 'WizardsNetworkBasic',
                'category'                => ['linux', 'network'],
                'selected_os'             => null,
                'necessity_of_assignment' => false
            ]
        ];

        return $wizards;
    }

}
