<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="WizardsIndex">
            <i class="fa-solid fa-wand-magic-sparkles"></i> <?php echo __('Wizards'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-wand-magic-sparkles"></i> <?php echo __('Network Basic'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Configuration Wizard: Network Basic'); ?>
                </h2>
            </div>
            <div class="panel-container show">
                <div class="panel-content fuelux">

                    <form ng-submit="submit();" class="form-horizontal">

                        <div class="wizard">
                            <ul class="nav nav-tabs step-anchor">
                                <li class="active">
                                    <span class="badge badge-info">
                                        <i class="fa fa-info"></i>
                                    </span>
                                    <?php echo __('Configure SNMP for Network Monitoring'); ?>
                                    <span class="chevron"></span>
                                </li>
                            </ul>
                        </div>


                        <div class="step-content">
                            <div class="card margin-top-20 margin-bottom-10">
                                <div class="card-body">
                                    <fieldset class="padding-bottom-20">
                                        <legend class="fs-md fieldset-legend-border-bottom">
                                            <h4>
                                                <?= __('SNMP Server Settings'); ?>
                                            </h4>
                                        </legend>

                                        <div class="form-group required">
                                            <label class="control-label" for="snmpVersion">
                                                <?php echo __('SNMP version'); ?>
                                            </label>
                                            <select
                                                    id="snmpVersion"
                                                    class="form-control"
                                                    chosen="{}"
                                                    ng-model="post.snmpVersion">
                                                <option value="1"><?= __('SNMP V 1'); ?></option>
                                                <option value="2"><?= __('SNMP V 2c'); ?></option>
                                                <option value="3"><?= __('SNMP V 3'); ?></option>
                                            </select>
                                        </div>

                                        <div class="form-group required" ng-class="{'has-error': errors.snmpCommunity}"
                                             ng-if="post.snmpVersion != 3">
                                            <label class="control-label" for="snmpCommunity">
                                                <?php echo __('Community'); ?>
                                            </label>
                                            <input
                                                    id="snmpCommunity"
                                                    class="form-control"
                                                    type="text"
                                                    placeholder="public"
                                                    ng-model="post.snmpCommunity">
                                            <div ng-repeat="error in errors.snmpCommunity">
                                                <div class="help-block text-danger">{{ error }}</div>
                                            </div>
                                        </div>

                                        <div ng-if="post.snmpVersion == 3">
                                            <div class="form-group">
                                                <label class="control-label" for="securityLevel">
                                                    <?php echo __('Security level'); ?>
                                                </label>
                                                <select
                                                        id="securityLevel"
                                                        class="form-control"
                                                        chosen="{}"
                                                        ng-model="post.securityLevel">
                                                    <option value="1"><?= __('authPriv'); ?></option>
                                                    <option value="2"><?= __('authNoPriv'); ?></option>
                                                    <option value="3"><?= __('noAuthNoPriv'); ?></option>
                                                </select>
                                                <div ng-show="post.securityLevel == 1">
                                                    <div class="help-block text-info">
                                                        <?= __('Communication with authentication and privacy. The protocols used for Authentication are MD5 and SHA and for Privacy, DES (Data Encryption Standard) and AES (Advanced Encryption Standard).'); ?>
                                                    </div>
                                                </div>
                                                <div ng-show="post.securityLevel == 2">
                                                    <div class="help-block text-info">
                                                        <?= __('Communication with authentication and without privacy. The protocols used for Authentication are MD5 and SHA (Secure Hash Algorithm).'); ?>
                                                    </div>
                                                </div>
                                                <div ng-show="post.securityLevel == 3">
                                                    <div class="help-block text-info">
                                                        <?= __('Communication without authentication and privacy.'); ?>
                                                    </div>
                                                </div>
                                            </div>
                                            <div>
                                                <div class="form-group">
                                                    <label class="control-label" for="authProtocol">
                                                        <?php echo __('Auth Protocol'); ?>
                                                    </label>
                                                    <select id="authProtocol"
                                                            class="form-control"
                                                            chosen="{}"
                                                            ng-model="post.authProtocol">
                                                        <option value="md5"><?= __('MD5'); ?></option>
                                                        <option value="sha"><?= __('SHA'); ?></option>
                                                    </select>
                                                </div>
                                                <div class="form-group">
                                                    <label class="control-label" for="securityName">
                                                        <?php echo __('Security name'); ?>
                                                    </label>
                                                    <input
                                                            id="securityName"
                                                            class="form-control"
                                                            type="text"
                                                            ng-model="post.securityName">
                                                    <div ng-repeat="error in errors.securityName">
                                                        <div class="help-block text-danger">{{ error }}</div>
                                                    </div>
                                                </div>
                                                <div class="form-group">
                                                    <label class="control-label" for="authPassword">
                                                        <?php echo __('Auth Password'); ?>
                                                    </label>
                                                    <input
                                                            id="authPassword"
                                                            class="form-control"
                                                            type="{{showPlainPassword ? 'text' : 'password'}}"
                                                            ng-model="post.authPassword">
                                                    <div ng-repeat="error in errors.authPassword">
                                                        <div class="help-block text-danger">{{ error }}</div>
                                                    </div>
                                                </div>
                                                <div class="form-group">
                                                    <label class="control-label" for="privacyProtocol">
                                                        <?php echo __('Privacy Protocol'); ?>
                                                    </label>
                                                    <select
                                                            id="privacyProtocol"
                                                            class="form-control"
                                                            chosen="{}"
                                                            ng-model="post.privacyProtocol">
                                                        <option value="des"><?= __('DES'); ?></option>
                                                        <option value="aes"><?= __('AES'); ?></option>
                                                        <option value="aes128"><?= __('AES128'); ?></option>
                                                        <option value="3des"><?= __('3DES'); ?></option>
                                                        <option value="3desde"><?= __('3DESDE'); ?></option>
                                                    </select>
                                                </div>
                                                <div class="form-group">
                                                    <label class="control-label" for="privacyPassword">
                                                        <?php echo __('Privacy password'); ?>
                                                    </label>
                                                    <input
                                                            id="privacyPassword"
                                                            class="form-control"
                                                            type="{{showPlainEncryptionPassword ? 'text' : 'password'}}"
                                                            ng-model="post.privacyPassword">
                                                </div>
                                            </div>
                                        </div>
                                    </fieldset>
                                    <fieldset>
                                        <legend class="fs-md fieldset-legend-border-bottom">
                                            <h4 ng-class="{'text-danger': errors.services}">
                                                <?= __('SNMP services'); ?>
                                                <span class="help-block italic text-primary">
                                                    <?= __('To avoiding duplicate service configuration, the existing services with the same name will be automatically deselected'); ?>
                                                </span>
                                                <div ng-repeat="error in errors.services">
                                                    <div class="help-block text-danger">
                                                        <i class="fas fa-exclamation-triangle"></i>
                                                        {{ error }}
                                                    </div>
                                                </div>
                                            </h4>
                                        </legend>
                                        <wizard-filter></wizard-filter>
                                        <ul class="no-padding">
                                            <ol class="padding-bottom-20 padding-left-0"
                                                ng-repeat="service in (filteredItems = (post.services | filterTagsinput:search.name))">
                                                <div class="form-group">
                                                    <div class="custom-control custom-checkbox">
                                                        <input type="checkbox"
                                                               id="{{service.name}}"
                                                               class="custom-control-input"
                                                               name="checkbox"
                                                               ng-model="service.createService">
                                                        <label class="custom-control-label custom-control-label-ok"
                                                               for="{{service.name}}">
                                                            {{service.name}}
                                                            <span class="help-block italic">
                                                                {{service.description}}
                                                            </span>
                                                        </label>
                                                    </div>
                                                </div>
                                                <div class="form-group {{detectColor(commandargument.commandargument.human_name)}}"
                                                     ng-repeat="commandargument in service.servicecommandargumentvalues">
                                                    {{commandargument.commandargument.human_name}}
                                                    <input class="form-control"
                                                           type="text"
                                                           ng-disabled="!service.createService"
                                                           ng-model="commandargument.value">
                                                </div>
                                            </ol>
                                        </ul>
                                    </fieldset>
                                    <fieldset>
                                        <legend class="fs-md fieldset-legend-border-bottom">
                                            <h4 ng-class="{'text-danger': errors.interfaces}">
                                                <?= __('SNNP Interfaces'); ?>
                                                <span class="help-block italic text-primary">
                                                    <?= __('To avoiding duplicate interface service configuration, the existing services with the same name will be automatically deselected'); ?>
                                                </span>
                                                <div ng-repeat="error in errors.interfaces">
                                                    <div class="help-block text-danger">
                                                        <i class="fas fa-exclamation-triangle"></i>
                                                        {{ error }}
                                                    </div>
                                                </div>
                                            </h4>
                                        </legend>
                                        <div class="row" ng-hide="interfaceServicetemplate">
                                            <div class="col-12">
                                                <div class="alert border-faded bg-transparent text-danger margin-top-20">
                                                    <div class="d-flex align-items-center">
                                                        <div class="alert-icon">
                                                            <span class="icon-stack icon-stack-md">
                                                                <i class="base-7 icon-stack-3x color-danger-600"></i>
                                                                <i class="fas fa-exclamation icon-stack-1x text-white"></i>
                                                            </span>
                                                        </div>
                                                        <div class="flex-1">
                                                            <span class="h5 color-danger-600">
                                                                <?= __('Service template for checking interfaces does not exist'); ?>
                                                            </span>
                                                            <br>
                                                            <?= __('Try to execute {0} to resolve the issue',
                                                                '<code>openitcockpit-update</code>'); ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row" ng-show="interfaceServicetemplate">
                                            <div class="col-12">
                                                <div class="alert border-faded bg-transparent text-secondary margin-top-20">
                                                    <div class="d-flex align-items-center">
                                                        <div class="alert-icon">
                                                            <span class="icon-stack icon-stack-md">
                                                                <i class="base-7 icon-stack-3x color-primary-600"></i>
                                                                <i class="fas fa-info icon-stack-1x text-white"></i>
                                                            </span>
                                                        </div>
                                                        <div class="flex-1">
                                                            <span class="h5 color-primary-600">
                                                                <?= __('Discovering Interfaces for SNMP Services'); ?>
                                                            </span>
                                                            <br>
                                                            <?= __('Scan this device and locate all of the interfaces that reside on the device. Only possible with valid SNMP configuration'); ?>
                                                        </div>
                                                        <button ng-click="startInterfaceDiscovery()" type="button"
                                                                class="btn btn-outline-primary btn-sm btn-w-m waves-effect waves-themed">
                                                            <span>
                                                                <i class="fa fa-spinner fa-spin"
                                                                   ng-show="executingDiscovery"></i>
                                                            </span>
                                                            <?= __('Start SNMP Interface discovery'); ?>
                                                        </button>
                                                    </div>
                                                </div>
                                                <div ng-repeat="error in errors.snmpcommand">
                                                    <div class="help-block text-danger">
                                                        <i class="fas fa-exclamation-triangle"></i>
                                                        {{ error }}
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <wizard-interface-filter></wizard-interface-filter>
                                        <ul class="no-padding">
                                            <ol class="padding-bottom-20 padding-left-0"
                                                ng-repeat="interface in (filteredInterfaces = (post.interfaces | filterTagsinput:search.value.name))">
                                                <div class="form-group">
                                                    <div class="custom-control custom-checkbox">
                                                        <input type="checkbox"
                                                               id="{{interface.name}}"
                                                               class="custom-control-input"
                                                               name="checkbox"
                                                               ng-model="interface.createService">
                                                        <label class="custom-control-label custom-control-label-ok"
                                                               for="{{interface.name}}">
                                                            {{interface.name}}
                                                            <span class="help-block italic">
                                                                {{interface.description}}
                                                            </span>
                                                        </label>
                                                    </div>
                                                </div>
                                                <div
                                                        class="form-group {{detectColor(commandargument.commandargument.human_name)}}"
                                                        ng-repeat="commandargument in interface.servicecommandargumentvalues">
                                                    {{commandargument.commandargument.human_name}}
                                                    <input class="form-control"
                                                           type="text"
                                                           ng-disabled="!interface.createService"
                                                           ng-model="commandargument.value"
                                                           ng-readonly="$first">
                                                </div>
                                            </ol>
                                        </ul>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="card margin-top-10">
                                <div class="card-body">
                                    <div class="float-right">
                                        <button type="submit" class="btn btn-primary" ng-disabled="disableSubmit">
                                            <span>
                                                <i class="fa fa-spinner fa-spin" ng-show="disableSubmit"></i>
                                            </span>
                                            <?php echo __('Create services'); ?>
                                        </button>
                                        <a back-button href="javascript:void(0);" fallback-state='WizardsIndex'
                                           class="btn btn-default"><?php echo __('Cancel'); ?></a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
